import tkinter as tk
from tkinter import PhotoImage
import time

def GetScreen(Title, Width, Height):
    global root
    root = tk.Tk()
    root.title(Title)
    root.geometry(f"{Width}x{Height}")

def ScreenResizable(Widht, Height):
    global root
    root.resizable(Widht, Height)

def UpdateScreen():
    global root
    root.update()

def LoopScreen():
    root.mainloop()


def AddTextButton(In, ButtonID, Xpos, Ypos, text, command):
    if In == "Window":
        parent = root
    elif "---" in In:
        I, N = In.split("---", 1)
        if N == "Box":
            parent = globals()[f"{I}_SQUARE_BOX"]
        elif N == "TextLabel":
            parent = globals()[f"{I}_Label"]
        elif N == "TextButton":
            parent = globals()[f"{I}_Button"]
        elif N == "Character":
            parent = globals()[f"{I}_Char"]
        else:
            parent = root
    else:
        parent = root
    text_button_object = tk.Button(parent, text=text, command=command)
    text_button_object.place(x=Xpos, y=Ypos)

    globals()[f"{ButtonID}_Button"] = text_button_object

def AddTextLabel(In, LabelID, Xpos, Ypos, text):
    if In == "Window":
        parent = root
    elif "---" in In:
        I, N = In.split("---", 1)
        if N == "Box":
            parent = globals()[f"{I}_SQUARE_BOX"]
        elif N == "TextLabel":
            parent = globals()[f"{I}_Label"]
        elif N == "TextButton":
            parent = globals()[f"{I}_Button"]
        elif N == "Character":
            parent = globals()[f"{I}_Char"]
        else:
            parent = root
    else:
        parent = root
    text_label_object = tk.Label(parent, text=text)
    text_label_object.place(x=Xpos, y=Ypos)

    globals()[f"{LabelID}_Label"] = text_label_object

def Config(Obj, ID, Obj_Set_A, Obj_Set_B):
    if Obj == "TextButton":
        if Obj_Set_A == "Text":
            globals()[f"{ID}_Button"].config(text=Obj_Set_B)
        if Obj_Set_A == "Position":
            Xpos, Ypos = Obj_Set_A.split("x", 1)
            globals()[f"{ID}_Button"].place(x=Xpos, y=Ypos)
    if Obj == "TextLabel":
        if Obj_Set_A == "Text":
            globals()[f"{ID}_Label"].config(text=Obj_Set_B)
        if Obj_Set_A == "Position":
            Xpos, Ypos = Obj_Set_A.split("x", 1)
            globals()[f"{ID}_Label"].place(x=Xpos, y=Ypos)
    if Obj == "Character":
        char_widget = globals()[f"{ID}_Char"]
        current_x = char_widget.winfo_x()
        current_y = char_widget.winfo_y()

        if Obj_Set_A == "Xpos":
            char_widget.place(x=Obj_Set_B, y=current_y)
        elif Obj_Set_A == "Ypos":
            char_widget.place(x=current_x, y=Obj_Set_B)

    if Obj == "Box":
        if Obj_Set_A == "Text":
            globals()[f"{ID}_SQUARE_BOX"].config(text=Obj_Set_B)
        if Obj_Set_A == "Position":
            Xpos, Ypos = Obj_Set_B.split("x", 1)
            globals()[f"{ID}_SQUARE_BOX"].place(x=int(Xpos), y=int(Ypos))


def GetInfo(InfoContent):
    global root
    if InfoContent == "Version":
        return "Pre-P-0.0.37", 3
    if InfoContent == "ScreenSize":
        return root.winfo_geometry()
    if "---" in InfoContent:
        parts = InfoContent.split("---")
        if len(parts) != 3:
            return None
        ID, TYPE, ATTR = parts
        if TYPE == "Box":
            widget = globals().get(f"{ID}_SQUARE_BOX")
        elif TYPE == "TextLabel":
            widget = globals().get(f"{ID}_Label")
        elif TYPE == "TextButton":
            widget = globals().get(f"{ID}_Button")
        elif TYPE == "Character":
            widget = globals().get(f"{ID}_Char")
        else:
            return None

        if not widget:
            return None

        if ATTR == "Xpos":
            return widget.winfo_x()
        elif ATTR == "Ypos":
            return widget.winfo_y()
        else:
            return None




def SetScreenSize(x, y):
    global root
    root.geometry(f"{x}x{y}")

def AddShape(PATH, ImageID, Width, Height):
    Photo = PhotoImage(file=PATH, height=Height, width=Width)
    globals()[f"{ImageID}_Image"] = Photo

def AddCharacter(In, CharID, ImageID, StartX, StartY):
    if In == "Window":
        parent = root
    elif "---" in In:
        I, N = In.split("---", 1)
        if N == "Box":
            parent = globals()[f"{I}_SQUARE_BOX"]
        elif N == "TextLabel":
            parent = globals()[f"{I}_Label"]
        elif N == "TextButton":
            parent = globals()[f"{I}_Button"]
        elif N == "Character":
            parent = globals()[f"{I}_Char"]
        else:
            parent = root
    else:
        parent = root
        Character = tk.Label(parent, image=globals()[f"{ImageID}_Image"])
        Character.place(x=StartX, y=StartY)
        globals()[f"{CharID}_Char"] = Character


def Wait(Value, Type):
    if Type == "Second":
        time.sleep(Value)
    if Type == "Minute":
        time.sleep(Value*60)
    if Type == "Hour":
        time.sleep(((Value*60)*60))
    if Type == "SplitSecond":
        time.sleep(Value/60)
    if Type == "SplitSecond":
        time.sleep(Value/60)

def GetCharacterX(CharID):
    return globals()[f"{CharID}_Char"].winfo_x()

def GetCharacterY(CharID):
    return globals()[f"{CharID}_Char"].winfo_y()


def ListenInputs(Object, Key, Function):
    global root
    ObjectID = Object
    if "MouseMove" in Key:
        Key = Key.replace("MouseMove", "Motion")

    if "MouseButton-1" in Key:
        Key = Key.replace("MouseButton-1", "Button-1")

    if "MouseButton-2" in Key:
        Key = Key.replace("MouseButton-2", "Button-2")

    if "MouseButton-3" in Key:
        Key = Key.replace("MouseButton-3", "Button-3")

    if "Mouse-Release" in Key:
        Key = Key.replace("Mouse-Release", "ButtonRelease")

    if "Mouse-Enter" in Key:
        Key = Key.replace("Mouse-Enter", "Enter")

    if "Mouse-Leave" in Key:
        Key = Key.replace("Mouse-Leave", "Leave")

    if "Mouse-Move" in Key:
        Key = Key.replace("Mouse-Move", "Motion")

    if "Mouse-Double-1" in Key:
        Key = Key.replace("Mouse-Double-1", "Double 1")

    if "Mouse-Double-2" in Key:
        Key = Key.replace("Mouse-Double-2", "Double 2")

    if "Mouse-Double-3" in Key:
        Key = Key.replace("Mouse-Double-3", "Double 3")

    if Object == "Window":
        Wait(1, "SplitSecond")
        root.bind(f"<{Key}>", Function)
    else:
        globals()[f"{Object}_SQUARE_BOX"].bind(f"<{Key}>", Function)

def AddBox(In, BoxID, Color, Text, StartX, StartY):
    if In == "Window":
        parent = root
    elif "---" in In:
        I, N = In.split("---", 1)
        if N == "Box":
            parent = globals()[f"{I}_SQUARE_BOX"]
        elif N == "TextLabel":
            parent = globals()[f"{I}_Label"]
        elif N == "TextButton":
            parent = globals()[f"{I}_Button"]
        elif N == "Character":
            parent = globals()[f"{I}_Char"]
        else:
            parent = root
    else:
        parent = root

    Color = Color.lower()
    BOX = tk.Label(parent, bg=Color, text=Text)
    BOX.place(x=StartX, y=StartY)
    globals()[f"{BoxID}_SQUARE_BOX"] = BOX
